﻿
-- to enable contained database on the instance
sp_configure 'show advanced options', 1
reconfigure
go
sp_configure 'contained database authentication', 1
reconfigure
go
sp_configure 'show advanced options', 0
reconfigure
go

CREATE DATABASE test_contained2 
CONTAINMENT = PARTIAL

USE test_contained
GO

-- user with authentication
CREATE USER bob WITH PASSWORD = 'StrongPW1'
GO

-- might cross an application boundary
select * from sys.dm_db_uncontained_entities
GO 

-- create an uncontained entity
CREATE PROC P1
AS 
SELECT * FROM sys.endpoints ;
GO
SELECT SO.name, UE.* FROM sys.dm_db_uncontained_entities AS UE
LEFT JOIN sys.objects AS SO
    ON UE.major_id = SO.object_id;
GO

CREATE FUNCTION dbo.f(@x INT) RETURNS INT
AS BEGIN 
      DECLARE @I INT = 1
      DECLARE @İ INT = 2
      RETURN @x * @i
END

-- In case-sensitive collation, produces an error
-- In case-insenitive Turkish collation, returns 8
-- In case-insenitive Latin collation, returns 4
SELECT dbo.f(4);
